/*
 * Copyright (c) 1996-1997 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by the MASH Research
 * 	Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char rcsid[] =
    "@(#) $Header: /home/ny4/jinyang/cvs/our-ns/classifier-addr.cc,v 1.1.1.1 2000/08/28 18:39:57 jinyang Exp $";
#endif

#include "config.h"
#include "packet.h"
#include "ip.h"
#include "classifier.h"

class AddressClassifier : public Classifier {
public:
	AddressClassifier() : mask_(~0), shift_(0) {
		bind("mask_", (int*)&mask_);
		bind("shift_", &shift_);
		bind("off_ip_", &off_ip_);
	}
protected:
	int classify(Packet *const p) {
		hdr_ip* h = (hdr_ip*)p->access(off_ip_);
#ifdef MONARCH
		if(shift_ == 8)
			return h->dst_;
		if(shift_ == 0)
			return h->dport_;
		fprintf(stderr, "Error: %s\n", __PRETTY_FUNCTION__);
		abort();
#else
		return ((h->dst() >> shift_) & mask_);
#endif
	}
	nsaddr_t mask_;
	int shift_;
	int off_ip_;
};

static class AddressClassifierClass : public TclClass {
public:
	AddressClassifierClass() : TclClass("Classifier/Addr") {}
	TclObject* create(int, const char*const*) {
		return (new AddressClassifier());
	}
} class_address_classifier;
