// -*- c++ -*-
// hdr_grid.cc
// Douglas S. J. De Couto
// 15 November 2000

// $Id: hdr_grid.cc,v 1.4 2000/12/11 18:35:47 decouto Exp $

#include <cmath>
#include "hdr_grid.h"
#include <packet.h>

int hdr_grid_lr::offset_;
int hdr_grid_encap::offset_;
int hdr_grid_proxy::offset_;

double
grid_location::dist(grid_location l1, grid_location l2)
{
  double dx = l1._x - l2._x;
  double dy = l1._y - l2._y;
  return sqrt(dx*dx + dy*dy);
}

static class Grid_LRHeaderClass : public PacketHeaderClass {
public:
  Grid_LRHeaderClass() : PacketHeaderClass("PacketHeader/Grid_LR", sizeof (hdr_grid_lr)) 
  { offset(&hdr_grid_lr::offset_); }
} class_Grid_LRHeader;

static class Grid_EncapHeaderClass : public PacketHeaderClass {
public:
  Grid_EncapHeaderClass() : PacketHeaderClass("PacketHeader/Grid_Encap", sizeof (hdr_grid_encap)) 
  { offset(&hdr_grid_encap::offset_); }
} class_Grid_EncapHdr;

static class Grid_ProxyClass : public PacketHeaderClass {
public:
  Grid_ProxyClass() : PacketHeaderClass("PacketHeader/Grid_Proxy", sizeof (hdr_grid_proxy)) 
  { offset(&hdr_grid_proxy::offset_); }
} class_Grid_ProxyHdr;
