// stolen and modified from click 1.1 15 nov 2000

/*
 * ipaddress.{cc,h} -- an IP address class. Useful for its hashcode()
 * method
 * Robert Morris / John Jannotti / Eddie Kohler
 *
 * Copyright (c) 1999-2000 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * Further elaboration of this license, including a DISCLAIMER OF ANY
 * WARRANTY, EXPRESS OR IMPLIED, is provided in the LICENSE file, which is
 * also accessible at http://www.pdos.lcs.mit.edu/click/license.html
 */

#include "ipaddress.h"
#include <cstdio>
#include <cctype>
#include <cstring>

IPAddress::IPAddress(const unsigned char *data)
{
  _addr = *(reinterpret_cast<const unsigned *>(data));
}



IPAddress::IPAddress(const String &str)
{
  /* 1. not clear this works, as i crappily hacked it from original code.
     2. maybe don't need it anyway... */
  int pos = 0, part;
  const char *s = ((String) str).cc();
  int len = str.length();

  unsigned char value[4];
  for (int d = 0; d < 4; d++) {
    if (d && pos < len && s[pos] == '.')
      pos++;
    if (pos >= len || !isdigit(s[pos]))
      goto bad;
    for (part = 0; pos < len && isdigit(s[pos]) && part <= 255; pos++)
      part = part*10 + s[pos] - '0';
    if (part > 255)
      goto bad;
    value[d] = part;
  }

  if (pos == len) {
    memcpy(&_addr, value, 4);
    return;
  }

 bad:
  _addr = 0;
}


String
IPAddress::s() const
{
  const unsigned char *p = data();
  char buf[20];
  sprintf(buf, "%d.%d.%d.%d", p[0], p[1], p[2], p[3]);
  return String(buf);
}


