// stolen and modified from click 1.1 15 nov 2000

#ifndef IPADDRESS_HH
#define IPADDRESS_HH

#include "string.hh"

class IPAddress {
  
  unsigned _addr;
  
 public:
  
  IPAddress()			: _addr(0) { }
  explicit IPAddress(const unsigned char *);
  IPAddress(unsigned);	// network byte order IP address
  explicit IPAddress(const String &);	// "18.26.4.99"
  explicit IPAddress(struct in_addr);
  
  // operator bool() const		{ return _addr != 0; }
  operator unsigned() const	{ return _addr; }
  unsigned addr() const		{ return _addr; }
  
  unsigned char *data();
  const unsigned char *data() const;
  
  unsigned hashcode() const	{ return _addr; }
  
  operator String() const	{ return s(); }
  String s() const;

  // bool operator<(IPAddress &a) const { return _addr < a._addr; }
};

inline
IPAddress::IPAddress(unsigned int n)
  : _addr(n)
{
}


inline bool
operator==(IPAddress a, IPAddress b)
{
  return a.addr() == b.addr();
}

inline bool
operator!=(IPAddress a, IPAddress b)
{
  return a.addr() != b.addr();
}

inline const unsigned char *
IPAddress::data() const
{
  return reinterpret_cast<const unsigned char *>(&_addr);
}

inline unsigned char *
IPAddress::data()
{
  return reinterpret_cast<unsigned char *>(&_addr);
}


#endif
