#!/usr/bin/perl

# usage: make-proxy-sim-edge.pl <n> <x> <y> <pct-with-loc> <out>

# N nodes don't know loc
# G nodes know loc

# relies on the fact that if fraction f of n nodes don't know loc,
# then they are numbered 1 to f*n by run-grid.tcl script

randomize();

$n = $ARGV[0];
$x = $ARGV[1];
$y = $ARGV[2];
$pct_no_loc = $ARGV[3];
$out = $ARGV[4];

$nn = $pct_no_loc * $n;
$ng = $n; # G nodes numbered $nn+1 to $ng

$yg = $pct_no_loc * $y;

# G nodes are placed in rectangle extending in length along the top of
# the universe, and depth from $y down to $yg.  No N nodes move in
# this region.  G nodes are static.

$setdest = "~/our-ns/cmu/setdest/setdest";

# generate lower part of rectangle with setdest, then append G node
# locations to the end.

system "$setdest -n $nn -p 0 -s 10 -t 300 -x $x -y $yg -f $ng -g $y > $out";

open(P, ">>$out"); # open for appending

for ($i = $nn + 1; $i <= $ng; $i++) {
    $pos_x = rand $x;
    $pos_y = rand ($y - $yg);
    $pos_y += $yg;

    print P "\$node_($i) set X_ $pos_x\n";
    print P "\$node_($i) set Y_ $pos_y\n";
    print P "\$node_($i) set Z_ 0.000000000000\n";
}

close P;

sub randomize {
    my $seed = $$;  #  $$ is pid
    my $buf;

    open(RAND_FILE,"/dev/urandom") or die "cannot open /dev/urandom";
    read(RAND_FILE,$buf, 4);
    $seed ^= $buf;

    close RAND_FILE;
    srand $seed;
}
