
#ifndef SPANPACKET_H
#define SPANPACKET_H

#define MAX_SPAN_NEIGHBORS    	128
#define MAX_SPAN_COORDINATORS 	16

#define SPAN_DEF_TTL       	32

#define SPAN_DROP_RECEIVED	"RCV"
#define SPAN_DROP_TX_FAILED	"TXF"
#define SPAN_DROP_SLEEP		"SLP"
#define SPAN_DROP_COORD		"CRD"
#define SPAN_GF_TTL		"TTL"
#define SPAN_GF_HOLE		"GFH"

#include <packet.h>

struct hdr_span {
#define SPAN_HELLO              1
#define SPAN_ROUTE_GF           4
  unsigned short type;
  bool is_coordinator;
  bool is_asleep;
  double nounce;
  int node_id;
  // end of piggy back data

  unsigned ncoordinators;
  unsigned coordinators[MAX_SPAN_COORDINATORS];
  unsigned nneighbors;
  unsigned neighbors[MAX_SPAN_NEIGHBORS];
 
  // these are meta data used by the transmiter
  double delay;
  unsigned tries;

  // just size of the piggy back
  inline int piggyback_size() { 
    return sizeof(unsigned short) +
           sizeof(bool) + sizeof(bool) +
           sizeof(double) +
	   sizeof(int);
  }

  inline int size() { 
    return sizeof(struct hdr_span)
           // delay and tries are just meta data, not in the real pkt
           -sizeof(double)-sizeof(unsigned); 
  }

  static int _offset;
};

#endif

