#!/usr/bin/perl

my $fn = $ARGV[0];
shift @ARGV;

$lastRTS = 0;
$diffRTS = 0;
$RTSLatency = 0;
$numRTS = 0;
$lastACK = 0;
$lastACKRecv = 0;
$ACKLatency = 0;
$numACK = 0;
$backoff = 0;
$numBackoff = 0;
$lastCTS = 0;
$CTSLatency = 0;
$numCTS = 0;
$lastDATA = 0;
$DATALatency = 0;
$numDATA = 0;

while (<>) {
  if ($_ =~ /^s ([0-9.]+) _1_ MAC  --- 0 MAC 44 /) { 
    if ($lastRTS == 0) { $lastRTS = $1; }
    else {
      $diffRTS += ($1-$lastRTS);
      $lastRTS = $1;
      $numRTS++;
    }
    if ($lastACKRecv > 0) {
      $backoff += ($lastRTS-$lastACKRecv);
      $numBackoff++;
    }
  }
  elsif ($_ =~ /^r ([0-9.]+) _2_ MAC  --- 0 MAC 44 /) {
    $RTSLatency += ($1 - $lastRTS);
  }
  elsif ($_ =~ /^s ([0-9.]+) _2_ MAC  --- 0 MAC 38 \[1c/) { 
    $lastCTS = $1;
  }
  elsif ($_ =~ /^r ([0-9.]+) _1_ MAC  --- 0 MAC 38 \[1c/) { 
    $CTSLatency += ($1 - $lastCTS);
    $numCTS++;
  }
  elsif ($_ =~ /^s ([0-9.]+) _2_ MAC  --- 0 MAC 38 \[1d/) {
    $lastACK = $1;
  }
  elsif ($_ =~ /^r ([0-9.]+) _1_ MAC  --- 0 MAC 38 \[1d/) { 
    $lastACKRecv = $1;
    $ACKLatency += ($1 - $lastACK);
    $numACK++;
  }
  elsif ($_ =~ /^s ([0-9.]+) _1_ MAC  --- [0-9]+ cbr 105/) { 
    $lastDATA = $1;
  }
  elsif ($_ =~ /^r ([0-9.]+) _2_ MAC  --- [0-9]+ cbr 53/) { 
    $DATALatency += ($1 - $lastDATA);
    $numDATA++;
  }
}

$avgDiffRTS = $diffRTS / $numRTS;
$avgRTSLatency = $RTSLatency / $numRTS;
$avgCTSLatency = $CTSLatency / $numCTS;
$avgDATALatency = $DATALatency / $numDATA;
$avgACKLatency = $ACKLatency / $numACK;
$avgBackoff = $backoff / $numBackoff;

$deferTimer1 = 0.00001;
$deferTimer2 = 0.00005;
$deferTimer3 = 0.00001;
$total = $avgRTSLatency + $deferTimer1 + $avgCTSLatency + $deferTimer2 +
         $avgDATALatency + $deferTimer3 + $avgACKLatency + $avgBackoff;

print "RTS latency:  $avgRTSLatency\n";
print "Defer timer:  0.00001\n";
print "CTS latency:  $avgCTSLatency\n";
print "Defer timer:  0.00005\n";
print "DATA latency: $avgDATALatency\n";
print "Defer timer:  0.00001\n";
print "ACK latency:  $avgACKLatency\n";
print "backoff:      $avgBackoff\n";
print "total:        $total\n";
print "RTS diff:     $avgDiffRTS\n";


