#!/usr/bin/perl

my $fn = $ARGV[0];
shift @ARGV;

my $sum = 0;
my $max = 0;
my $min = 999;

my @values;
my %announce;

while (<>) {
  if ($_ =~ /^# ([0-9.]+): ([0-9]+) announce/) {
    if ($announce->[$2]) {
      print "$2 duplicate announce at $1\n";
    } else {
      $announce->[$2] = $1;
    }
  } 
  elsif ($_ =~ /^# ([0-9.]+): ([0-9]+) withdraw/) {
    if ($announce->[$2]) {
      my $duration = $1-$announce->[$2];
      push (@values, $duration);
      $sum += $duration;
      if ($duration > $max) { $max = $duration; }
      if ($duration < $min) { $min = $duration; }
      $announce->[$2] = 0;
    } else {
      print "$2 extra withdraw at $1\n";
    }
  } 
}

if ($#values >= 0) {
  $avg = $sum / ($#values+1);
  $varsum = 0;
  for (my $i=0; $i <= $#values; $i++) {
    $varsum += (($values[$i]-$avg)*($values[$i]-$avg));
  }
  $var = $varsum / ($#values+1);
  $std = sqrt($var);
  print "avg: $avg std: $std max: $max min: $min\n";
}

print "$#values number of coordinator periods\n";


