#!/usr/bin/perl

$time     = 40;
$mobility = 0;
$route    = 1;

$routers     = 100;
$connections = 20;

$period = 20;
$router_x = 800;
$router_y = 800;

$pktsize = 16;
$interval = 0.1;

$range  = 250;
$bw     = 2000000;
$max_speed = 10;

$nodes = $routers + $connections*2;
$max_x = $router_x + 400;
$max_y = $router_y + 400;

print <<EOF
#
# nodes: $nodes, max time: $time.00, max x: $max_x.00, max y: $max_y.00
# nominal range: $range link bw: $bw
# pause: 0.00, max speed: $max_speed

EOF
;

# initial positions

for (my $i = 1; $i <= $connections; $i++) {
  my $pos_x = 50+rand 100;
  my $pos_y = 100+rand ($router_y+200);
  my $pos_z = 0;
  print "\$node_($i) set X_ $pos_x\n";
  print "\$node_($i) set Y_ $pos_y\n";
  print "\$node_($i) set Z_ $pos_z\n";
}

for (my $i = $connections+1; $i <= $connections*2; $i++) {
  my $pos_x = 250+$router_x+rand 100;
  my $pos_y = 100+rand ($router_y+200);
  my $pos_z = 0;
  print "\$node_($i) set X_ $pos_x\n";
  print "\$node_($i) set Y_ $pos_y\n";
  print "\$node_($i) set Z_ $pos_z\n";
}

for (my $i = $connections*2+1; $i <= $nodes; $i++) {
  my $pos_x = 200+rand $router_x;
  my $pos_y = 200+rand $router_y;
  my $pos_z = 0;
  print "\$node_($i) set X_ $pos_x\n";
  print "\$node_($i) set Y_ $pos_y\n";
  print "\$node_($i) set Z_ $pos_z\n";
}

if ($route) {
  my $pkts = ($time - 30)/$interval;
  for (my $i = 1; $i <= $connections; $i++) { 
    my $dst = $i+$connections;
    print "set cbr_($i) [\$ns_ create-connection CBR \$node_($i) CBR \$node_($dst) 0]\n";
    print "\$cbr_($i) set packetSize_ $pktsize\n";
    print "\$cbr_($i) set interval_ $interval\n";
    print "\$cbr_($i) set random_ 1\n";
    print "\$cbr_($i) set maxpkts_ $pkts\n";
    my $st = 20 + rand(5);
    print "\$ns_ at $st \"\$cbr_($i) start\"\n";
  }
}

# dump tables

$dumps = ($time/$period)-1;

for (my $j = 0; $j < $dumps; $j++) {
  $dt = $j*$period+$period;
  for (my $i = 1; $i <= $nodes; $i++) {
    if ($i == 1) {
      my $dtt = $dt-1;
      print "\$ns_ at $dtt \"\$node_($i) dump-tables\"\n";
    } else {
      print "\$ns_ at $dt \"\$node_($i) dump-tables\"\n";
    }
  }
}
for (my $i = 1; $i <= $nodes; $i++) {
  my $t1 = $time-2;
  my $t2 = $time-1;
  if ($i == 1) {
    print "\$ns_ at $t1 \"\$node_($i) dump-tables\"\n";
  } else {
    print "\$ns_ at $t2 \"\$node_($i) dump-tables\"\n";
  }
}


# movements

if ($mobility) {
  my %movetime;
  for (my $i = $connections*2+1; $i <= $nodes; $i++) { $movetime->[$i] = 0; }
  my $not_done = 1;
  while ($not_done == 1) {
    $not_done = 0;
    for (my $i = $connections*2+1; $i <= $nodes; $i++) {
      if ($movetime->[$i] < $time) {
        my $pos_x = 200+rand $router_x;
        my $pos_y = 200+rand $router_y;
        my $speed = rand $max_speed;
        print "\$ns_ at $movetime->[$i] \"\$node_($i) setdest $pos_x $pos_y $speed\"\n";
        my $next = 20 + rand 30;
        $movetime->[$i] += $next;
	$not_done = 1;
      } 
    }
  }
}

