#!/usr/bin/perl
use strict;

if ($#ARGV < 1) {
    print "usage: <num_node> <x> <y>\n";
    exit 2;
}
my $num_node = shift;
my $x = shift;
my $y = shift;

randomize();

printf "#
# nodes: $num_node, max time: 300.000000, max x: $x.00, max y: $y.00, chain: 0
# nominal range: 250.00 link bw: 2000000.00
# pause: 0.00, max speed: 0.00

";

my $i;
my $pos_x;
my $pos_y;
for ($i=1;$i<=$num_node;$i++) {
    $pos_x = rand $x;
    $pos_y = rand $y;
    printf "\$node_($i) set X_ $pos_x\n";
    printf "\$node_($i) set Y_ $pos_y\n";
    printf "\$node_($i) set Z_ 0.000000000000\n";
}

sub randomize {
    my $seed = $$;  #  $$ is pid
    my $buf;

    open(RAND_FILE,"/dev/urandom") or die "cannot open /dev/urandom";
    read(RAND_FILE,$buf, 4);
    $seed ^= $buf;

    close RAND_FILE;
    srand $seed;
}
